module type SEXPR =
   sig
     type sexpr
     val nil : sexpr
     val cons : sexpr * sexpr  -> sexpr
     val node : string -> sexpr
     val car : sexpr -> sexpr
     val cdr : sexpr -> sexpr
     val null : sexpr -> bool
     val atom : sexpr -> bool
     val leaf : sexpr -> string
     val rplaca: sexpr * sexpr -> unit
     val rplacd: sexpr * sexpr -> unit
     exception NotALeaf
     exception NotACons
   end